from telethon import TelegramClient, functions, types, utils
from sys import argv
import clientInformation 

script, botUserName, incidentDisplayName, titleMessage, mainInformation = argv

client = TelegramClient('swarming', clientInformation.api_id, clientInformation.api_hash)

async def main(): 
    chat = await client(functions.channels.CreateChannelRequest(
        about = incidentDisplayName,
        title = incidentDisplayName,
        megagroup = True
    ))
    chatId = chat.chats[0].id
    
    chatInvite = client(functions.channels.InviteToChannelRequest(
        channel = chatId,
        users = [botUserName]
    ))

    client.parse_mode = 'html'
    pinnedMessage = await client.send_message(chatId, titleMessage.replace(';;', '\n'))
    await client.pin_message(chatId, pinnedMessage, notify = True)
    await client.send_message(chatId, mainInformation.replace(';;', '\n'))


    chatInvite = await client(functions.messages.ExportChatInviteRequest(chatId))
    botEntity = await client.get_entity(botUserName)
    createdChatEntity = await client.get_entity(chatId)
    await client.edit_admin(createdChatEntity, botEntity, is_admin = True)
    await client.edit_permissions(createdChatEntity, invite_users = True)
    channelId = utils.get_peer_id(types.PeerChannel(chatId))
    result = {"chatId": channelId, "chatInviteLink": chatInvite.link}
    print(result)

with client:
    client.loop.run_until_complete(main())